/*
  RCTractor.h - Library for controlling RC Tractors.
  Created by Oisin O'Conchubhair, September 20, 2015.
  Released into the public domain.
*/
#ifndef RCTractorGuy_h
#define RCTractorGuy_h

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

#include <Servo.h>


class RCTractor
{
  public:
    RCTractor(int Motor_1_PWM, int Motor_1_Dir_1, int Motor_1_Dir_2, int Motor_2_PWM, int Motor_2_Dir_1, int Motor_2_Dir_2, int Steering, int Rear_Link, int Front_Link, int Left_Ind,int Right_Ind,int Head_Lights,int Tail_Lights,int Work_Lights,int Accessory_Lights,int Left_Beacon, int Right_Beacon);
    void Drive(int Drive_Val,int Steering_Val);
    void LiftingArms(int Rear_Val, int Front_Val);
    void Lights(int Light_Val);
    void Timer();
    void begin();
    void Trailer(uint8_t buf[16]);
    void SetServoLimits(int Ser1_Min, int Ser1_Max, int Ser2_Min, int Ser2_Max, int Ser3_Min, int Ser3_Max);
    void MotorConfiguration(int MotorConfig, int UsePCF);
	long ReadVcc();

  private:
	Servo _Steering_Servo;
	Servo _Rear_Link_Servo;
	Servo _Front_Link_Servo;
	void Drive_Motor();
	void LeftIndicator();
	void RightIndicator();
	void HazardIndicator();
	void IndicatorsOff();
  	void BeaconControl();

};


#endif
