/*

*/

// This section describes the vehicle

// Variables used in the program
byte ID = 11; // Vehicle ID Number
int Active = 1; // Variable to determine if the tractor is in active
int Last_Data_Timer = 0;
int Controller_Locked = 0;
int Receive_Count = 0;


int Controller_ID = 0;

uint8_t buf[16]; // Array to store recieved data

#include <SPI.h>
#include "RCTractorGuyRF24.h"
#include "RCTractorGuy.h"

// Set up nRF24L01 radio on SPI bus plus pins 9 & 10
RF24 radio(9, 10);
RCTractor R620(5, A2, A1, 0, 0, 0, 8, 7, 0, 2, 4, 3, 6, A0, 0, 0, 0);

// Controller Address
const uint64_t Controller[5] = { 0xE8E8F0F0E1LL, 0xE8E8F0F0E2LL, 0xE8E8F0F0E3LL, 0xE8E8F0F0E4LL, 0xE8E8F0F0E5LL};

void setup(void)
{
  // Start Serial Communications
  Serial.begin(9600);

  // Start the NRF24L01
  radio.begin();

  // Enable Ack Payloads to automatically send data back with the Acknowledge
  radio.enableAckPayload();

  // Initialise the library
  R620.begin();

  // Set the servo limits
  // (Steering Servo Min, Steering Servo Max, Rear Link Servo Min, Rear Link Servo Max, Front Link Servo Min, Front Link Servo Max)
  R620.SetServoLimits(0x70, 0x15, 0x10, 0x70, 0x00, 0xFF);

  // Set the motor configuration
  // (Motor configuration 1 = 1 motor or 2 = 2 motors or 3 = tracks, Do you use a PCF8574 0=no or 1=yes)
  R620.MotorConfiguration(1, 0);

  All_Controllers();
}

void loop(void)
{
 /* if (Controller_Locked == 0) {

    // if there is data ready
    if ( radio.available() )
    {


    }
  }

  if (Controller_Locked == 1) {
   */ //Lock_Controller();
    buf[0] = 0;

    // if there is data ready
    if ( radio.available() )
    {
      Controller_ID = Controller_ID - 1;
     // Lock_Controller();

      long Vehicle_Voltage = R620.ReadVcc();

        // Fetch the payload.
        radio.read( buf, sizeof(buf));

      // Add an ack packet for the next time around.  This is a simple
      // packet counter
      radio.writeAckPayload( 1, &Vehicle_Voltage, sizeof(Vehicle_Voltage));

      // We recieved a string of ten bytes, four ID, one command and six data values but they may not be for this tractor
      if (buf[0] == ID) { // Confirm that the correct vehicle ID has been recieved
        Controller_ID = Controller_ID - 1;
        //Lock_Controller();
        R620.Drive(buf[2], buf[3]);
        R620.LiftingArms(buf[5], buf[6]);
        R620.Lights(buf[9]);        // Update the lights

        Last_Data_Timer = 10000;
        Active = 1;
      }
    }
    else if (Last_Data_Timer != 0) {
      Last_Data_Timer = Last_Data_Timer - 1;
    }
    else if (Last_Data_Timer == 0 && Active == 1) {
      Active = 0;
      R620.Lights(0x03);
      R620.Drive(125, 125);
    }

    R620.Timer();


    /* if (Active == 1) {
      }
      else if (Controller_Locked != 0) {
       All_Controllers();
       Controller_Locked = 0;
      }*/
  //}
}

void Lock_Controller() {
  /*if (Controller_Locked == 0) {
    radio.stopListening();

    radio.openReadingPipe(1, Controller[Controller_ID]); // Set Address of Controller 1
    radio.openReadingPipe(2, 0); // Set Address of Controller 2
    radio.openReadingPipe(3, 0); // Set Address of Controller 1
    radio.openReadingPipe(4, 0); // Set Address of Controller 2

    radio.startListening();
  }*/
}

void All_Controllers() {
  radio.stopListening();

  radio.openReadingPipe(1, Controller[0]); // Set Address of Controller 1
  radio.openReadingPipe(2, Controller[1]); // Set Address of Controller 2
  radio.openReadingPipe(3, Controller[2]); // Set Address of Controller 1
  radio.openReadingPipe(4, Controller[3]); // Set Address of Controller 2
  radio.openReadingPipe(5, Controller[4]); // Set Address of Controller 2

  radio.startListening();
}

